Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_zdf.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_zdf.F90	(revision 8533)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_zdf.F90	(revision 8534)
@@ -2,6 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE icethd_zdf ***
-   !!                       heat diffusion in sea ice 
-   !!                   computation of surface and inner T  
+   !!   sea-ice: vertical heat diffusion in sea ice (computation of temperatures) 
    !!======================================================================
    !! History :  LIM  ! 02-2003 (M. Vancoppenolle) original 1D code
@@ -14,20 +13,20 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!   'key_lim3'                                       ESIM sea-ice model
    !!----------------------------------------------------------------------
-   USE par_oce        ! ocean parameters
+   USE dom_oce        ! ocean space and time domain
    USE phycst         ! physical constants (ocean directory) 
    USE ice            ! sea-ice: variables
-   USE ice1D          ! sea-ice: thermodynamics
+   USE ice1D          ! sea-ice: thermodynamics variables
    !
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! MPP library
-   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
+   USE lib_fortran    ! fortran utilities (glob_sum + no signed zero)
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   ice_thd_zdf        ! called by ice_thd
-   PUBLIC   ice_thd_zdf_init   ! called by ice_stp
+   PUBLIC   ice_thd_zdf        ! called by icethd
+   PUBLIC   ice_thd_zdf_init   ! called by icestp
 
    !!** namelist (namthd_zdf) **
@@ -47,5 +46,5 @@
 
    SUBROUTINE ice_thd_zdf
-      !!------------------------------------------------------------------
+      !!-------------------------------------------------------------------
       !!                ***  ROUTINE ice_thd_zdf  ***
       !! ** Purpose :
@@ -63,9 +62,9 @@
       !!
       !!           The successive steps of this routine are
-      !!           1.  Thermal conductivity at the interfaces of the ice layers
-      !!           2.  Internal absorbed radiation
-      !!           3.  Scale factors due to non-uniform grid
+      !!           1.  initialization of ice-snow layers thicknesses
+      !!           2.  Internal absorbed and transmitted radiation
+      !!           Then iterative procedure begins
+      !!           3.  Thermal conductivity
       !!           4.  Kappa factors
-      !!           Then iterative procedure begins
       !!           5.  specific heat in the ice
       !!           6.  eta factors
@@ -75,4 +74,5 @@
       !!           Iterative procedure ends according to a criterion on evolution
       !!           of temperature
+      !!           10. Fluxes at the interfaces
       !!
       !! ** Inputs / Ouputs : (global commons)
@@ -82,5 +82,5 @@
       !!           number of layers in the ice/snow: nlay_i, nlay_s
       !!           total ice/snow thickness : ht_i_1d, ht_s_1d
-      !!------------------------------------------------------------------
+      !!-------------------------------------------------------------------
       INTEGER ::   ji, jk         ! spatial loop index
       INTEGER ::   numeq          ! current reference number of equation
@@ -149,7 +149,7 @@
       END DO
 
-      !------------------------------------------------------------------------------!
-      ! 1) Initialization                                                            !
-      !------------------------------------------------------------------------------!
+      !------------------
+      ! 1) Initialization
+      !------------------
       DO ji = 1, nidx
          isnow(ji)= 1._wp - MAX( 0._wp , SIGN(1._wp, - ht_s_1d(ji) ) )  ! is there snow or not
@@ -173,13 +173,11 @@
       t_su_1d(1:nidx)   = MIN( t_su_1d(1:nidx), rt0 - ztsu_err )   ! necessary
       !
-      !------------------------------------------------------------------------------|
-      ! 2) Radiation	                                                             |
-      !------------------------------------------------------------------------------|
+      !-------------
+      ! 2) Radiation
+      !-------------
       !
       z1_hsu = 1._wp / 0.1_wp ! threshold for the computation of i0
       DO ji = 1, nidx
-         !-------------------
-         ! Computation of i0
-         !-------------------
+         ! --- Computation of i0 --- !
          ! i0 describes the fraction of solar radiation which does not contribute
          ! to the surface energy budget but rather penetrates inside the ice.
@@ -193,8 +191,6 @@
          i0(ji) = ( 1._wp - isnow(ji) ) * ( fr1_i0_1d(ji) + zfac * fr2_i0_1d(ji) )
 
-         !-------------------------------------------------------
-         ! Solar radiation absorbed / transmitted at the surface
-         ! Derivative of the non solar flux
-         !-------------------------------------------------------
+         ! --- Solar radiation absorbed / transmitted at the surface --- !
+         !     Derivative of the non solar flux
          zfsw   (ji)     =  qsr_ice_1d(ji) * ( 1 - i0(ji) )   ! Shortwave radiation absorbed at surface
          zftrice(ji)     =  qsr_ice_1d(ji) *       i0(ji)     ! Solar radiation transmitted below the surface layer
@@ -203,7 +199,5 @@
       END DO
 
-      !---------------------------------------------------------
-      ! Transmission - absorption of solar radiation in the ice
-      !---------------------------------------------------------
+      ! --- Transmission/absorption of solar radiation in the ice --- !
       zradtr_s(1:nidx,0) = zftrice(1:nidx)
       DO jk = 1, nlay_s
@@ -227,12 +221,10 @@
 
       ftr_ice_1d(1:nidx) = zradtr_i(1:nidx,nlay_i)   ! record radiation transmitted below the ice
-
-      !------------------------------------------------------------------------------|
-      !  3) Iterative procedure begins                                               |
-      !------------------------------------------------------------------------------|
       !
       iconv    =  0          ! number of iterations
       zdti_max =  1000._wp   ! maximal value of error on all points
-      DO WHILE ( zdti_max > zdti_bnd .AND. iconv < iconv_max )
+      !                                                          !----------------------------!
+      DO WHILE ( zdti_max > zdti_bnd .AND. iconv < iconv_max )   ! Iterative procedure begins !
+         !                                                       !----------------------------!
          !
          iconv = iconv + 1
@@ -241,8 +233,7 @@
          ztsb(1:nidx,:) = t_s_1d(1:nidx,:)
          !
-         !------------------------------------------------------------------------------|
-         ! 4) Sea ice thermal conductivity                                              |
-         !------------------------------------------------------------------------------|
-         !
+         !--------------------------------
+         ! 3) Sea ice thermal conductivity
+         !--------------------------------
          IF( ln_cndi_U64 ) THEN         !-- Untersteiner (1964) formula: k = k0 + beta.S/T
             !
@@ -277,8 +268,5 @@
          ztcond_i(1:nidx,:) = MAX( zkimin, ztcond_i(1:nidx,:) )        
          !
-         !------------------------------------------------------------------------------|
-         !  5) G(he) - enhancement of thermal conductivity in mono-category case        |
-         !------------------------------------------------------------------------------|
-         !
+         !--- G(he) : enhancement of thermal conductivity in mono-category case
          ! Computation of effective thermal conductivity G(h)
          ! Used in mono-category case only to simulate an ITD implicitly
@@ -309,8 +297,7 @@
          END SELECT
          !
-         !------------------------------------------------------------------------------|
-         !  6) kappa factors                                                            |
-         !------------------------------------------------------------------------------|
-         !
+         !-----------------
+         ! 4) kappa factors
+         !-----------------
          !--- Snow
          DO jk = 0, nlay_s-1
@@ -338,8 +325,7 @@
          END DO
          !
-         !------------------------------------------------------------------------------|
-         ! 7) Sea ice specific heat, eta factors                                        |
-         !------------------------------------------------------------------------------|
-         !
+         !--------------------------------------
+         ! 5) Sea ice specific heat, eta factors
+         !--------------------------------------
          DO jk = 1, nlay_i
             DO ji = 1, nidx
@@ -355,8 +341,7 @@
          END DO
          !
-         !------------------------------------------------------------------------------|
-         ! 8) surface flux computation                                                  |
-         !------------------------------------------------------------------------------|
-         !
+         !----------------------------
+         ! 6) surface flux computation
+         !----------------------------
          IF ( ln_dqns_i ) THEN 
             DO ji = 1, nidx
@@ -370,8 +355,7 @@
          END DO
          !
-         !------------------------------------------------------------------------------|
-         ! 9) tridiagonal system terms                                                  |
-         !------------------------------------------------------------------------------|
-         !
+         !----------------------------
+         ! 7) tridiagonal system terms
+         !----------------------------
          !!layer denotes the number of the layer in the snow or in the ice
          !!numeq denotes the reference number of the equation in the tridiagonal
@@ -414,9 +398,7 @@
 
          DO ji = 1, nidx
-            IF ( ht_s_1d(ji) > 0.0 ) THEN
-               !
-               !------------------------------------------------------------------------------|
-               !  snow-covered cells                                                          |
-               !------------------------------------------------------------------------------|
+            !                               !---------------------!
+            IF ( ht_s_1d(ji) > 0.0 ) THEN   !  snow-covered cells !
+               !                            !---------------------!
                !
                !!snow interior terms (bottom equation has the same form as the others)
@@ -435,9 +417,6 @@
                ENDIF
 
-               IF ( t_su_1d(ji) < rt0 ) THEN
-
-                  !------------------------------------------------------------------------------|
-                  !  case 1 : no surface melting - snow present                                  |
-                  !------------------------------------------------------------------------------|
+               IF ( t_su_1d(ji) < rt0 ) THEN   !--  case 1 : no surface melting
+
                   numeqmin(ji)    =  1
                   numeqmax(ji)    =  nlay_i + nlay_s + 1
@@ -455,9 +434,5 @@
                   zindterm(ji,2) =  ztsold(ji,1) + zeta_s(ji,1) * zradab_s(ji,1)
 
-               ELSE 
-                  !
-                  !------------------------------------------------------------------------------|
-                  !  case 2 : surface is melting - snow present                                  |
-                  !------------------------------------------------------------------------------|
+               ELSE                            !--  case 2 : surface is melting
                   !
                   numeqmin(ji)    =  2
@@ -471,15 +446,9 @@
                      &             ( zradab_s(ji,1) + zkappa_s(ji,0) * zg1s * t_su_1d(ji) ) 
                ENDIF
-            ELSE
+            !                               !---------------------!
+            ELSE                            ! cells without snow  !
+               !                            !---------------------!
                !
-               !------------------------------------------------------------------------------|
-               !  cells without snow                                                          |
-               !------------------------------------------------------------------------------|
-               !
-               IF ( t_su_1d(ji) < rt0 ) THEN
-                  !
-                  !------------------------------------------------------------------------------|
-                  !  case 3 : no surface melting - no snow                                       |
-                  !------------------------------------------------------------------------------|
+               IF ( t_su_1d(ji) < rt0 ) THEN   !--  case 1 : no surface melting
                   !
                   numeqmin(ji)      =  nlay_s + 1
@@ -512,11 +481,6 @@
                   ENDIF
 
-               ELSE
-
-                  !
-                  !------------------------------------------------------------------------------|
-                  ! case 4 : surface is melting - no snow                                        |
-                  !------------------------------------------------------------------------------|
-                  !
+               ELSE                            !--  case 2 : surface is melting
+
                   numeqmin(ji)    =  nlay_s + 2
                   numeqmax(ji)    =  nlay_i + nlay_s + 1
@@ -543,11 +507,9 @@
          END DO
          !
-         !------------------------------------------------------------------------------|
-         ! 10) tridiagonal system solving                                               |
-         !------------------------------------------------------------------------------|
-         !
+         !------------------------------
+         ! 8) tridiagonal system solving
+         !------------------------------
          ! Solve the tridiagonal system with Gauss elimination method.
-         ! Thomas algorithm, from Computational fluid Dynamics, J.D. ANDERSON, 
-         ! McGraw-Hill 1984.	
+         ! Thomas algorithm, from Computational fluid Dynamics, J.D. ANDERSON, McGraw-Hill 1984.	
 
          maxnumeqmax = 0
@@ -595,8 +557,7 @@
          END DO
          !
-         !--------------------------------------------------------------------------
-         !  11) Has the scheme converged ?, end of the iterative procedure         |
-         !--------------------------------------------------------------------------
-         !
+         !--------------------------------------------------------------
+         ! 9) Has the scheme converged ?, end of the iterative procedure
+         !--------------------------------------------------------------
          ! check that nowhere it has started to melt
          ! zdti_max is a measure of error, it has to be under zdti_bnd
@@ -632,9 +593,8 @@
          WRITE(numout,*) ' iconv    : ', iconv
       ENDIF
-
-      !
-      !-------------------------------------------------------------------------!
-      !   12) Fluxes at the interfaces                                          !
-      !-------------------------------------------------------------------------!
+      !
+      !-----------------------------
+      ! 10) Fluxes at the interfaces
+      !-----------------------------
       DO ji = 1, nidx
          !                                ! surface ice conduction flux
@@ -694,5 +654,5 @@
 
    SUBROUTINE ice_thd_enmelt
-      !!-----------------------------------------------------------------------
+      !!-------------------------------------------------------------------
       !!                   ***  ROUTINE ice_thd_enmelt *** 
       !!                 
@@ -764,5 +724,5 @@
       !
       IF ( ( ln_cndi_U64 .AND. ln_cndi_P07 ) .OR. ( .NOT.ln_cndi_U64 .AND. .NOT.ln_cndi_P07 ) ) THEN
-         CALL ctl_stop( 'ice_thd_zdf_init: choose one and only one formulation for thermal conductivity (ln_cndi_U64 or ln_cndi_P07)' )
+         CALL ctl_stop( 'ice_thd_zdf_init: choose one and only one formulation for thermal conduction (ln_cndi_U64 or ln_cndi_P07)' )
       ENDIF
       !
@@ -771,5 +731,5 @@
 #else
    !!----------------------------------------------------------------------
-   !!                   Dummy Module                 No ESIM sea-ice model
+   !!   Default option       Dummy Module             No ESIM sea-ice model
    !!----------------------------------------------------------------------
 #endif
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 8533)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 8534)
@@ -16,5 +16,5 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                    LIM 3.0 sea-ice model
+   !!   'key_lim3'                                       ESIM sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_update_alloc : allocate the iceupdate arrays
@@ -23,5 +23,4 @@
    !!   ice_update_tau   : update i- and j-stresses, and its modulus at the ocean surface
    !!----------------------------------------------------------------------
-   USE par_oce        ! ocean parameters
    USE oce     , ONLY : sshn, sshb
    USE phycst         ! physical constants
@@ -42,8 +41,8 @@
    !
    USE in_out_manager ! I/O manager
-   USE iom            ! xIO server
-   USE lbclnk         ! ocean lateral boundary condition - MPP exchanges
+   USE iom            ! I/O manager library
    USE lib_mpp        ! MPP library
-   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
+   USE lib_fortran    ! fortran utilities (glob_sum + no signed zero)
+   USE lbclnk         ! lateral boundary conditions (or mpp links)
    USE timing         ! Timing
 
@@ -110,5 +109,5 @@
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zalb_cs, zalb_os     ! 3D workspace
       !!---------------------------------------------------------------------
-      IF( nn_timing == 1 )  CALL timing_start('ice_update_flx')
+      IF( nn_timing == 1 )  CALL timing_start('ice_update')
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -213,5 +212,5 @@
       IF( ln_icectl                      )   CALL ice_prt       (kt, iiceprt, jiceprt, 3, 'Final state ice_update') ! prints
       IF( ln_ctl                         )   CALL ice_prt3D     ('iceupdate')                                       ! prints
-      IF( nn_timing == 1                 )   CALL timing_stop   ('ice_update_flx')                                  ! timing
+      IF( nn_timing == 1                 )   CALL timing_stop   ('ice_update')                                      ! timing
       !
    END SUBROUTINE ice_update_flx
@@ -251,5 +250,5 @@
       !!---------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('ice_update_tau')
+      IF( nn_timing == 1 )  CALL timing_start('ice_update')
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -297,5 +296,5 @@
       CALL lbc_lnk_multi( utau, 'U', -1., vtau, 'V', -1. )   ! lateral boundary condition
       !
-      IF( nn_timing == 1 )  CALL timing_stop('ice_update_tau')
+      IF( nn_timing == 1 )  CALL timing_stop('ice_update')
       !  
    END SUBROUTINE ice_update_tau
@@ -373,5 +372,5 @@
 #else
    !!----------------------------------------------------------------------
-   !!   Default option         Dummy module          NO  LIM3 sea-ice model
+   !!   Default option         Dummy module           NO ESIM sea-ice model
    !!----------------------------------------------------------------------
 #endif 
